import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Spaceship here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BusFix extends SmoothMover
{
    private double speedX;
    private double speedY;

    public void act() 
    {
        doTurn();

        doMove();
    }

    private void doMove()
    {
        if (Greenfoot.isKeyDown("up"))
        {
            double radians = Math.toRadians(getRotation());
            double moveSpeed = 0.1;

            double accX = Math.cos(radians) * moveSpeed;
            double accY = Math.sin(radians) * moveSpeed;

            speedX = speedX + accX;
            speedY = speedY + accY;
        }
        clampSpeedAndBrake();
        setLocation(getExactX() + speedX, getExactY() + speedY);
    }

    private void doTurn()
    {
        if (Greenfoot.isKeyDown("left"))
        {
            turn(-4);
        }
        if (Greenfoot.isKeyDown("right"))
        {
            turn(4);
        }
    }

    @Override
    public void setLocation(double x, double y)
    {
        int width = getWorld().getWidth();
        int height = getWorld().getHeight();

        while (x >= width)
        {
            x -= width;
        }
        while (x < 0)
        {
            x += width;
        }
        while (y >= height)
        {
            y -= height;
        }
        while (y < 0)
        {
            y += height;
        }

        super.setLocation(x, y);
    }
    
    private static double calculateDirection(double x, double y)
    {
        return Math.toDegrees(Math.atan2(y, x));
    }
    
    private static double calculateMagnitude(double x, double y)
    {
        //return Math.sqrt(x * x + y * y);
        return Math.hypot(x, y);
    }
    
    private static double calculateX(double dir, double speed)
    {
        return Math.cos(Math.toRadians(dir)) * speed;
    }
    
    private static double calculateY(double dir, double speed)
    {
        return Math.sin(Math.toRadians(dir)) * speed;
    }
    
    private void clampSpeedAndBrake()
    {
        double dir = calculateDirection(speedX, speedY);
        double speed = calculateMagnitude(speedX, speedY);
        
        final double MAX_SPEED = 10;
        
        if (speed > MAX_SPEED)
        {
            speed = MAX_SPEED;
        }
        
        if (Greenfoot.isKeyDown("down"))
        {
            speed = Math.max(0, speed - 0.1);
            if (speed > 5)
                layDownRubber();
            //speed *= 0.98;
        }
        //if (speed <= 0.01)
        //{
        //    speed = 0;
        //}
        
        speedX = calculateX(dir, speed);
        speedY = calculateY(dir, speed);
    }
    
    private void layDownRubber()
    {
        double wheelPos[][] = 
          { {45, 26}, {45, -26}
          , {-45, 26}, {-45, -26} };
          
        for (double[] pos : wheelPos)
        {
            double x = pos[0];
            double y = pos[1];
            
            double dir = calculateDirection(x, y);
            double dist = calculateMagnitude(x, y);
            
            dir += getRotation();
            
            double worldX = getX() + calculateX(dir, dist);
            double worldY = getY() + calculateY(dir, dist);
            
            if (worldX >= 0 && worldX < getWorld().getWidth()
               && worldY >= 0 && worldY < getWorld().getHeight())
            {
                TyreTrack track = new TyreTrack();
                // Orient it in the same direction as the bus (wheels point same way as bus):
                track.setRotation(getRotation());
                getWorld().addObject(track, (int)worldX, (int)worldY);
            }
        }
    }
}

